/*
          
JJMASeries.mqh 
PriceSeries.mqh 
  (): MetaTrader\experts\include\
Heiken Ashi#.mq4
  (): MetaTrader\indicators\
*/
//+------------------------------------------------------------------+  
//|                                                     3c_JMACD.mq4 | 
//|                 3c_JMACD: Copyright  2006,     Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright  2006, Nikolay Kositsin"
#property copyright "edas@tdd.lt"
#property link "farria@mail.redcom.ru" 
//----     
#property indicator_separate_window
//----   
#property indicator_buffers 5
//----  
#property indicator_color1  BlueViolet 
#property indicator_color2  Blue
#property indicator_color3  Magenta
#property indicator_color4  Gray
#property indicator_color5  Red
//----   
#property indicator_width1 0
#property indicator_width2 2 
#property indicator_width3 2
#property indicator_width4 2
//----    
#property indicator_style1 4
//----    
#property indicator_style5 4
//----    
#property indicator_level1 0.0
#property indicator_levelcolor Red 
#property indicator_levelstyle 4
//----    --------------------------------------------------------------------------------------------------+
extern int FastJMA=12;   //    JMA
extern int SlowJMA=55;   //    JMA
extern int S.shift =0;
extern int SignalJMA=9;  //    JMA
extern int displace = 5;
extern bool ShowArrows = true; //will arrows be shown
extern bool ShowLevels  = true; //will levels be shown
extern int JMACD_Phase  = 100; // ,    -100 ... +100,    x  JMACD 
extern int Signal_Phase = 100; // ,    -100 ... +100,    x    
extern int Input_Price_Customs = 0;/*  ,      
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//----  
double Ind_buffer1[];
double Ind_buffer2[];
double Ind_buffer3[];
double Ind_buffer4[];
double Ind_buffer5[];
string Name="Arrow";
//+------------------------------------------------------------------+  
//----+   JJMASeries 
//----+   JJMASeriesResize 
//----+   JJMASeriesAlert  
//----+   JMA_ErrDescr  
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//----+   PriceSeries
//----+   PriceSeriesAlert 
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| JMACD initialization function                                    |
//+------------------------------------------------------------------+ 
int init()
  {
//----   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(4,DRAW_LINE);
//---- 4     
if(!SetIndexBuffer(0,Ind_buffer1)&& 
   !SetIndexBuffer(1,Ind_buffer2)&& 
   !SetIndexBuffer(2,Ind_buffer3)&& 
   !SetIndexBuffer(3,Ind_buffer4)&& 
   !SetIndexBuffer(4,Ind_buffer5))
//   Print("   !");
   Print("Cannot define indicator buffers!");
//----   ,      
   SetIndexEmptyValue(0,0.0);  
   SetIndexEmptyValue(1,0.0); 
   SetIndexEmptyValue(2,0.0); 
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);  
//----        
   IndicatorShortName("JMACD_divergence("+FastJMA+","+SlowJMA+","+SignalJMA+")");
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,"Up_Trend");
   SetIndexLabel(2,"Down_Trend");
   SetIndexLabel(3,"Straight_Trend");
   SetIndexLabel(4,"Signal");
//----    (    )        
   IndicatorDigits(0);
//----+      JJMASeries, nJMAnumber=2(    JJMASeries)
   if (JJMASeriesResize(3)!=3)return(-1);
//----       
   JJMASeriesAlert (0,"FastJMA",FastJMA);
   JJMASeriesAlert (0,"SlowJMA",SlowJMA);
   JJMASeriesAlert (0,"SignalJMA",SignalJMA);
   JJMASeriesAlert (1,"JMACD_Phase", JMACD_Phase);
   JJMASeriesAlert (1,"Signal_Phase", Signal_Phase);
   PriceSeriesAlert(Input_Price_Customs);
//----  
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
for(int i = ObjectsTotal() - 1; i >= 0; i--)
{
    Name = ObjectName(i);
    if( StringSubstr( Name, 0, 4 ) == "Bull" )
       ObjectDelete( Name );   
    if( StringSubstr( Name, 0, 4 ) == "Bear" )
       ObjectDelete( Name );   
}       
//----
   return(0);
  }  
//+------------------------------------------------------------------+ 
//| JMACD iteration function                                         |
//+------------------------------------------------------------------+ 
int start()
  {
   //----      
   double F.JMA,S.JMA,JMACD,Series,trend,Signal;
   //----+        
   int reset,limit,MaxBar,MaxBarS,counted_bars=IndicatorCounted();
   //----    
   if (counted_bars<0)return(-1);
   //----      
   if (counted_bars>0) counted_bars--;
   //----     ,        
   limit=Bars-counted_bars-1; MaxBar=Bars-1; MaxBarS=MaxBar-30;
   static int PrevSignal = 0;
   double Last_Price_Peak, Last_Indic_Peak, Last_Price_Through, Last_Indic_Through;
   double Last_Price_Peak2,Last_Indic_Peak2,Last_Price_Through2,Last_Indic_Through2;
   
   //----+     JMACD
   for(int bar=limit; bar>=0; bar--)
    {
     //----+    PriceSeries     Series
     Series=PriceSeries(Input_Price_Customs, bar);  
       
     //----+     JJMASeries   0, 1.  nJMA.Phase  nJMA.Length      (nJMA.din=0)
     F.JMA=JJMASeries(0,0,MaxBar,limit,JMACD_Phase,FastJMA,Series,bar,reset);
     //----+       
     if(reset!=0)return(-1);
     //+---------------------------------------------------------------------+
     S.JMA=JJMASeries(1,0,MaxBar,limit,JMACD_Phase,SlowJMA,Series,bar,reset);
     //----+       
     if(reset!=0)return(-1); 
     //+---------------------------------------------------------------------+
     //----+   JMACD
     JMACD=F.JMA-S.JMA;
     //----+    JMACD    
     JMACD = JMACD/Point*10;
     Ind_buffer1[bar]=JMACD;
     
     //---- +SSSSSSSSSSSSSSSS <<<    >>> SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
     trend=JMACD-Ind_buffer1[bar+1];     
     if(trend>0.0)     {Ind_buffer2[bar]=JMACD;  Ind_buffer3[bar]=0.0;    Ind_buffer4[bar]=0.0;}
     else{if(trend<0.0){Ind_buffer2[bar]=0.0;    Ind_buffer3[bar]=JMACD;  Ind_buffer4[bar]=0.0;}
     else              {Ind_buffer2[bar]=0.0;    Ind_buffer3[bar]=0.0;    Ind_buffer4[bar]=JMACD;}}    
     //---- +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
     
     //----+    JJMASeries   2, (nJMA.din=0,     nJMA.MaxBar   30  . .   JMA ) 
     Signal=JJMASeries(2,0,MaxBarS,limit,Signal_Phase,SignalJMA,JMACD,bar,reset);
     //----+       
     if(reset!=0)return(-1);
     Ind_buffer5[bar]=Signal;
     
//     if ( Ind_buffer1[bar] > Ind_buffer1[bar+1] )
     
     if (ShowArrows == true)
    {       
     // if indicator begins to rise
     if ( Ind_buffer1[bar] > Ind_buffer1[bar+1] && Ind_buffer1[bar+1] < Ind_buffer1[bar+2] && Ind_buffer1[bar+1] < 0 ) //
      {
        if ( Low[bar+1] < Last_Price_Through  && Ind_buffer1[bar+1] > Last_Indic_Through )  //jeigu yra divergencija
        {      
         Name = "Bull_div_" + DoubleToStr( Time[bar+0], 0 );   
         ObjectCreate(Name, OBJ_ARROW, 0, Time[bar+0], Low[bar+0] - displace*Point );
         ObjectSet(Name, OBJPROP_ARROWCODE, 241 );
         ObjectSet(Name, OBJPROP_COLOR, Magenta);  
        }
      Last_Indic_Through2 = Last_Indic_Through; //new indicator value
      Last_Price_Through2 = Last_Price_Through; //new price value 

      Last_Indic_Through = Ind_buffer1[bar+1]; 
      Last_Price_Through = Low[bar+1];         
  
      }
      
     //if JMACD begins drop
     if ( Ind_buffer1[bar] < Ind_buffer1[bar+1] && Ind_buffer1[bar+1] > Ind_buffer1[bar+2] && Ind_buffer1[bar+1] > 0)
      {
      
      if ( High[bar+1] > Last_Price_Peak  && Ind_buffer1[bar+1] < Last_Indic_Peak )  //if divergence
        {      
         Last_Indic_Peak2 = Ind_buffer1[bar+1];
         Last_Price_Peak2 = High[bar+1];
          
          if (High[bar+2] > High[bar+2]) 
               Last_Price_Peak2 = High[bar+2];
         Name = "Bear_div_" + DoubleToStr( Time[bar+0], 0 );   
         ObjectCreate(Name, OBJ_ARROW, 0, Time[bar+0], High[bar+0] + displace*Point );
         ObjectSet(Name, OBJPROP_ARROWCODE, 242 );
         ObjectSet(Name, OBJPROP_COLOR, Red);  

     if (ShowLevels)
     {
     int TopBar = iHighest(Symbol(), Period(), MODE_HIGH, 15, 0);
     double Top = High[TopBar];
     string topas = DoubleToStr(Top,4) + Time[0];//DoubleToStr(Top,4) + Time[0];
         ObjectCreate(topas, OBJ_TREND, 0, Time[TopBar], High[TopBar], Time[0], High[TopBar] ); //JMACD is not visible with this line
//         ObjectCreate("12345", OBJ_HLINE, 0, 0, 1.2800); //High[bar+2]);
//         ObjectSet(topas, OBJPROP_STYLE, STYLE_SOLID );
//         ObjectSet(topas, OBJPROP_COLOR, Red);
     }


        }

     Last_Indic_Peak2 = Last_Indic_Peak; 
     Last_Price_Peak2 = Last_Price_Peak; 
     

      
     Last_Indic_Peak = Ind_buffer1[bar+1];
     Last_Price_Peak = High[bar+1];
     } //if arrows pabaiga

     if (Ind_buffer1[bar] < 0 && Ind_buffer1[bar+1] < 0 && Ind_buffer1[bar+2] < 0) //if 3 bars < 0
     {
     Last_Indic_Peak = 0;
     Last_Price_Peak = 0;
     Last_Indic_Peak2 = 0;
     Last_Price_Peak2 = 0;
     } 
       
     if (Ind_buffer1[bar] > 0 && Ind_buffer1[bar+1] > 0 && Ind_buffer1[bar+2] > 0) 
     {
     Last_Indic_Through = 0;
     Last_Price_Through = 0;
     Last_Indic_Through = 0;
     Last_Price_Through = 0;
     }  
      
     }  //for bars pabaiga
     
   } //ciklo pabaiga
   
      string  Message  = "JMACD " + FastJMA+ ", " + SlowJMA;
      string  Message1 = Symbol() + " TF " + Period() +  " min "  + " @ " + DoubleToStr(Bid,Digits);
      
   
     if ( Ind_buffer1[0] > Ind_buffer1[1] && Ind_buffer1[1] < Ind_buffer1[2] && PrevSignal <= 0 && Period() > 5)
      {
 //     Alert(Message +" sloped UP " + Message1);
      PrevSignal = 1;
      }
  if ( Ind_buffer1[0] < Ind_buffer1[1] && Ind_buffer1[1] > Ind_buffer1[2] && PrevSignal >= 0 && Period() > 5)
      {
 //     Alert(Message +" sloped DOWN " + Message1);    
      PrevSignal = -1;
      }

      
   
   if(limit>=MaxBar-31){int iii=MaxBar-31;Ind_buffer2[iii]=0;Ind_buffer3[iii]=0;Ind_buffer4[iii]=0;} 
//----    
   return(0);
  } 
//+-------------------------------------------------------------------------------+

